/* 
   Teddy Bear and Leo Lion 
   Teddy_bear.ino
   The robot follows the obstacle by rotating and maintaining the distance
   Claudio Gasparini - www.cad-tutor.com/alvik
*/

#include "Arduino_Alvik.h"
Arduino_Alvik alvik;

float reference = 10.0; // Desired distance from obstacle (in cm)
float error = 0.0;
float distances[5];

void setup() {
  while ((!Serial) && (millis() < 3000));
  alvik.begin();
}

void loop() {
  // Reads distances from sensors (0 = sinistra, 1 = sinistra frontale, 2 = frontale, 3 = destra frontale, 4 = destra)
  alvik.get_distance(distances[0], distances[1], distances[2], distances[3], distances[4]);
  
  Serial.print("Frontale: "); Serial.print(distances[2]);
  Serial.print(" | Sinistra: "); Serial.print(distances[1]);
  Serial.print(" | Destra: "); Serial.println(distances[3]);

  // Controllo distanza frontale
  error = distances[2] - reference;
  float forward_speed = constrain(error * 10.0, -50.0, 50.0); // Limitiamo la velocità tra -50 e 50

  // Controllo per seguire lateralmente
  float turn_speed = 0.0;
  
  if (distances[1] < distances[3]) { 
    // Nearest obstacle on the left, turn left
    turn_speed = -22.0; 
  } else if (distances[3] < distances[1]) { 
    // Nearest obstacle on the right, turn right
    turn_speed = 22.0; 
  }

  // Set the wheel speed: forward speed + rotation speed
  alvik.set_wheels_speed(forward_speed + turn_speed, forward_speed - turn_speed);

  delay(100);
}
